﻿
namespace Startup
{
	using System;

	using Windows.ApplicationModel;
	using Windows.ApplicationModel.Activation;
	using Windows.ApplicationModel.Core;
	using Windows.UI.Core;
	using Windows.UI.Xaml;
	using Windows.UI.Xaml.Controls;

	/// <summary>
	/// Provides application-specific behavior to supplement the default Application class.
	/// </summary>
	sealed partial class App : Application
	{
		/// <summary>
		/// Initializes the singleton application object.  This is the first line of authored code
		/// executed, and as such is the logical equivalent of main() or WinMain().
		/// </summary>
		public App()
		{
			this.InitializeComponent();
			this.Suspending += OnSuspending;
			this.Resuming += OnResuming;
		}

		private Window win;


		protected override void OnWindowCreated(WindowCreatedEventArgs args)
		{
			base.OnWindowCreated(args);
			System.Diagnostics.Debug.WriteLine("OnWindowCreated Thread Id:{0}", Environment.CurrentManagedThreadId);
		}

		/// <summary>
		/// Invoked when the application is launched normally by the end user.  Other entry points
		/// will be used such as when the application is launched to open a specific file.
		/// </summary>
		/// <param name="e">Details about the launch request and process.</param>
		protected override void OnLaunched(LaunchActivatedEventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("Launched Thread Id:{0}", Environment.CurrentManagedThreadId);

			//Indica la tipologia di applicazione.
			ActivationKind kind = e.Kind;

			Frame rootFrame = Window.Current.Content as Frame;

			// Do not repeat app initialization when the Window already has content,
			// just ensure that the window is active
			if (rootFrame == null)
			{
				// Create a Frame to act as the navigation context and navigate to the first page
				rootFrame = new Frame();

				if (e.PreviousExecutionState == ApplicationExecutionState.Terminated)
				{
					//TODO: Load state from previously suspended application
				}

				// Place the frame in the current Window
				Window.Current.Content = rootFrame;
			}

			if (rootFrame.Content == null)
			{
				// When the navigation stack isn't restored navigate to the first page,
				// configuring the new page by passing required information as a navigation
				// parameter
				rootFrame.Navigate(typeof(MainPage), e.Arguments);
			}

			// Ensure the current window is active
			Window.Current.Activate();
		}

		/// <summary>
		/// Invoked when app is activated as share target
		/// </summary>
		/// <param name="args">Activation parameters</param>
		protected override void OnShareTargetActivated(ShareTargetActivatedEventArgs args)
		{
			base.OnShareTargetActivated(args);
		}

		/// <summary>
		/// Invoked when application execution is being suspended.  Application state is saved
		/// without knowing whether the application will be terminated or resumed with the contents
		/// of memory still intact.
		/// </summary>
		/// <param name="sender">The source of the suspend request.</param>
		/// <param name="e">Details about the suspend request.</param>
		private void OnSuspending(object sender, SuspendingEventArgs e)
		{
			//Suspending code
		}

		/// <summary>
		/// Called when app resumes
		/// </summary>
		/// <param name="sender">The sender.</param>
		/// <param name="e">The e.</param>
		/// <exception cref="System.NotImplementedException"></exception>
		private void OnResuming(object sender, object e)
		{
			//Resuming code
		}
	}
}
