﻿
namespace Startup
{
	using System;

	using Windows.ApplicationModel.Core;
	using Windows.UI;
	using Windows.UI.Core;
	using Windows.UI.ViewManagement;
	using Windows.UI.Xaml;
	using Windows.UI.Xaml.Controls;
	using Windows.UI.Xaml.Media;

	/// <summary>
	/// An empty page that can be used on its own or navigated to within a Frame.
	/// </summary>
	public sealed partial class MainPage : Page
	{
		public MainPage()
		{
			this.InitializeComponent();
		}

		private async void OpenNewView(object sender, RoutedEventArgs e)
		{
			System.Diagnostics.Debug.WriteLine("Current view thread Id:{0}", Environment.CurrentManagedThreadId);
			//Get current core window
			ApplicationView currentAppView = ApplicationView.GetForCurrentView();

			//Create new View
			CoreApplicationView newCoreAppView = CoreApplication.CreateNewView();

			await newCoreAppView.Dispatcher.RunAsync(
				CoreDispatcherPriority.Normal,
				() =>
				{
					System.Diagnostics.Debug.WriteLine("New View thread Id:{0}", Environment.CurrentManagedThreadId);
					ApplicationView newAppView = ApplicationView.GetForCurrentView();

					Grid grid = new Grid() { Background = new SolidColorBrush(Colors.LightSeaGreen) };
					grid.Children.Add(
					  new Viewbox()
					  {
						  Child = new TextBlock()
						  {
							  Text = CoreApplication.Views.Count.ToString()
						  }
					  });

					Window.Current.Content = grid;

					// Display secondary window   
					ApplicationViewSwitcher.TryShowAsStandaloneAsync(
						newAppView.Id,
						ViewSizePreference.UseMore,
						currentAppView.Id,
						ViewSizePreference.UseHalf);
				});
		}
	}
}
